ICode9

精准搜索请尝试: 精确搜索
首页 > 其他分享> 文章详细

HDU--1054--二分图--树状dp

2020-02-24 15:36:01  阅读:251  来源: 互联网

标签:node HDU 1054 int ip number head dp


Bob enjoys playing computer games, especially strategic games, but sometimes he cannot find the solution fast enough and then he is very sad. Now he has the following problem. He must defend a medieval city, the roads of which form a tree. He has to put the minimum number of soldiers on the nodes so that they can observe all the edges. Can you help him?

Your program should find the minimum number of soldiers that Bob has to put for a given tree.

The input file contains several data sets in text format. Each data set represents a tree with the following description:

the number of nodes
the description of each node in the following format
node_identifier:(number_of_roads) node_identifier1 node_identifier2 ... node_identifier
or
node_identifier:(0)

The node identifiers are integer numbers between 0 and n-1, for n nodes (0 < n <= 1500). Every edge appears only once in the input data.

For example for the tree:



the solution is one soldier ( at the node 1).

The output should be printed on the standard output. For each given input data set, print one integer number in a single line that gives the result (the minimum number of soldiers). An example is given in the following table:

Input
4
0:(1) 1
1:(2) 2 3
2:(0)
3:(0)
5
3:(3) 1 4 2
1:(1) 0
2:(0)
0:(0)
4:(0)
Output
1
2

题意:给定一棵树求最小边覆盖的点数;
思路:1.二分图的最大匹配做,最大匹配数就是最小边覆盖;2.树形dp:dp[u][0]表示以u为根节点的树u点不取的数目,dp[u][1]表示以u为根节点的树u点取的数目.状态转移方程:dp[u][0]+=dp[v][1];dp[u][1]+=min(dp[v][0],dp[v][1]);

#include<cstdio>
#include<cstring>
#include<algorithm>
#include<iostream>
using namespace std;
const int maxn=1550;
int head[maxn],ip;
int dp[maxn][2],n;
struct note{
    int v,next;
}edge[maxn*4];
void init(){
    memset(head,-1,sizeof(head));
    ip=0;
}
void addedge(int u,int v){
    edge[ip].v=v,edge[ip].next=head[u],head[u]=ip++;
}
void dfs(int u,int pre){
    dp[u][1]=1;
    dp[u][0]=0;
    for(int i=head[u];i!=-1;i=edge[i].next){
        int v=edge[i].v;
        if(v==pre) continue;
        dfs(v,u);
        dp[u][0]+=dp[v][1];
        dp[u][1]+=min(dp[v][0],dp[v][1]);
    }
}
int main(){
    while(~scanf("%d",&n)){
        init();
        for(int i=0;i<n;i++){
            int u,k;
            scanf("%d:(%d)",&u,&k);
            u++;
            for(int j=0;j<k;j++){
                int v;
                scanf("%d",&v);
                v++;
                addedge(u,v);
                addedge(v,u);
            }
        }
        memset(dp,0,sizeof(dp));
        dfs(1,-1);
        printf("%d\n",min(dp[1][0],dp[1][1]));
    }
    return 0;
}

 

queque_heiyaa 发布了162 篇原创文章 · 获赞 73 · 访问量 1万+ 私信 关注

标签:node,HDU,1054,int,ip,number,head,dp
来源: https://blog.csdn.net/queque_heiya/article/details/104478330

本站声明: 1. iCode9 技术分享网(下文简称本站)提供的所有内容,仅供技术学习、探讨和分享;
2. 关于本站的所有留言、评论、转载及引用,纯属内容发起人的个人观点,与本站观点和立场无关;
3. 关于本站的所有言论和文字,纯属内容发起人的个人观点,与本站观点和立场无关;
4. 本站文章均是网友提供,不完全保证技术分享内容的完整性、准确性、时效性、风险性和版权归属;如您发现该文章侵犯了您的权益,可联系我们第一时间进行删除;
5. 本站为非盈利性的个人网站,所有内容不会用来进行牟利,也不会利用任何形式的广告来间接获益,纯粹是为了广大技术爱好者提供技术内容和技术思想的分享性交流网站。

专注分享技术,共同学习,共同进步。侵权联系[81616952@qq.com]

Copyright (C)ICode9.com, All Rights Reserved.

ICode9版权所有